
// 1210dma.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "1210dma.h"
#include "1210dmaDlg.h"
#include "CardIDDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// C1210dmaApp

BEGIN_MESSAGE_MAP(C1210dmaApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// C1210dmaApp construction

C1210dmaApp::C1210dmaApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only C1210dmaApp object

C1210dmaApp theApp;


// C1210dmaApp initialization

BOOL C1210dmaApp::InitInstance()
{
	int nCardID = 0;
	I16 hCard;
	CString strTemp;
	INT_PTR nResponse;
	I16 nErr;
	U16 wModuleNum;
	USBDAQ_DEVICE AvailModules[MAX_USB_DEVICE];
	
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	nErr = UD_Device_Scan(&wModuleNum, AvailModules );

	if( nErr != NoError )
	{
		strTemp.Format( TEXT("UD_Device_Scan() failed, error code = %d"), nErr );
		AfxMessageBox( strTemp );
		return FALSE;

	}

	CCardIDDlg CardDlg( wModuleNum, AvailModules );

	nResponse = CardDlg.DoModal();
	if (nResponse == IDOK)
	{

		nCardID = CardDlg.GetCardID();

		if ((hCard=UD_Register_Card(USB_1210, nCardID)) < 0) 
		{
			strTemp.Format( TEXT("Register_Card Error = %d"), hCard);
			AfxMessageBox( strTemp );
		}
		else
		{
			C1210dmaDlg dlg(hCard);
			m_pMainWnd = &dlg;
			nResponse = dlg.DoModal();
			if (nResponse == IDOK)
			{
				// TODO: Place code here to handle when the dialog is
				//  dismissed with OK
			}
			else if (nResponse == IDCANCEL)
			{
				// TODO: Place code here to handle when the dialog is
				//  dismissed with Cancel
			}

			if (hCard >= 0) UD_Release_Card(hCard);
		}

	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
