
// 1210dmaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "1210dma.h"
#include "1210dmaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CRect plotRect;
ULONG AI_SAMPLE_COUNT;  //2048

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// C1210dmaDlg dialog

C1210dmaDlg::C1210dmaDlg(I16 hCard, CWnd* pParent /*=NULL*/)
	: CDialog(C1210dmaDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	n_PlotWidth = n_PlotHeight = -1;
 	OnBrush = OffBrush = NULL;

	min_val = 0x00;
	max_val = 0xFFFF;

	m_hCard = hCard;
	m_wSelectedChans = 1;
	m_nTimer = -1;
	m_hMem=NULL;

	AI_SAMPLE_COUNT = 2048;

}

void C1210dmaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_SCANCHAN, m_cbScanChans);
	DDX_Control(pDX, IDC_COMBO_GAIN, m_cbADCGain);
}

BEGIN_MESSAGE_MAP(C1210dmaDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_WM_VSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBO_SCANCHAN, &C1210dmaDlg::OnScanChanSelchange)
	ON_BN_CLICKED(IDC_BT_START, &C1210dmaDlg::OnStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BT_STOP, &C1210dmaDlg::OnBnClickedBtStop)
	ON_CBN_SELCHANGE(IDC_COMBO_GAIN, &C1210dmaDlg::OnComboGainSelchange)
END_MESSAGE_MAP()


// C1210dmaDlg message handlers

BOOL C1210dmaDlg::OnInitDialog()
{
	DWORD   mem_size;
	CString strTemp;

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	x_divider = 5; y_divider = 4;	

	OnBrush = CreateSolidBrush( RGB(255,0,0) );
	OffBrush = CreateSolidBrush( RGB(125,0,0) );

	RedPen.CreatePen( PS_SOLID, 1, RGB(255,0,0));
	YellowPen.CreatePen( PS_SOLID, 1, RGB(255,255,0));
	BluePen.CreatePen( PS_SOLID, 1, RGB(0,0,255));
	LTGreenPen.CreatePen( PS_SOLID, 1, RGB(0,128,0));

	if(	n_PlotWidth == -1 && n_PlotHeight == -1 )
	{
		((CWnd*)GetDlgItem(IDC_STATIC_DRAW))->GetWindowRect(&plotRect);
		ScreenToClient(&plotRect);

		n_PlotWidth = min( plotRect.Width(), 512);
		n_PlotHeight = plotRect.Height() - 10;
	}

	m_cbADCGain.SetCurSel( 0 );
	m_wRange = AD_B_10_V;
	max_range = 10.0;
	min_range = -10.0;
	
	m_fSampleRate = 2000000.0f; 

	// allocate a memory for user DMA buffer
	mem_size = AI_SAMPLE_COUNT * sizeof(I16) * 4; // 4 channels
	m_hMem = GlobalAlloc(GMEM_ZEROINIT, mem_size);
	m_pAIBuf = (U16*) GlobalLock(m_hMem);

	if (m_pAIBuf == NULL )
	{
		AfxMessageBox( TEXT("Memory allocation failed"), MB_OK);
	}
	
	GlobalFix(m_hMem);

	// set the default SampleRate
	SetDlgItemInt( IDC_EDIT_SAMPLE_RATE, (UINT)(m_fSampleRate) );
	m_cbScanChans.SetCurSel( 0 );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void C1210dmaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void C1210dmaDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		redraw_display_area();
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR C1210dmaDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void C1210dmaDlg::redraw_display_area(void)
{
	CPen *oldPen;

	int oldMode;
	COLORREF oldColor;
	CString tick_str;
	CRect tmp_rect, tick_rect;

	CPen minor_tick( PS_SOLID,1,RGB(132,130,132) );
//		CPen y_grid( PS_SOLID,1,RGB(206,203,132) );

	int i, x_intv, y_intv;
//		long total_sec;

	CClientDC dc_plot(this);

	// draw the base-line for x-y axises
	oldPen = (CPen *)dc_plot.SelectStockObject(BLACK_PEN);

	// redraw the background
	dc_plot.FillSolidRect( plotRect, RGB(0,0,0) );

	// Re-Draw the AREA for Y-Lable
	{
		CBrush DIALOG_BRUSH;
		CRect redraw_area, full_client;

		GetClientRect(&full_client);
		ScreenToClient(&full_client);

		redraw_area.left = full_client.left;
		redraw_area.top = plotRect.top - 5;
		redraw_area.right = plotRect.left - 3;
		redraw_area.bottom = plotRect.bottom + 10;

		DIALOG_BRUSH.CreateSysColorBrush( COLOR_3DFACE );

		dc_plot.FillRect( redraw_area, &DIALOG_BRUSH );

		DIALOG_BRUSH.DeleteObject();
	}

	dc_plot.MoveTo( plotRect.left - 3, plotRect.top );
	dc_plot.LineTo( plotRect.left - 3, plotRect.bottom );

	// calculate the interval for tick/grid
	y_intv = (plotRect.Height() - 10) /y_divider;
	x_intv = plotRect.Width()/x_divider;


	// set the color for tick
	oldColor = dc_plot.SetTextColor( RGB(0,0,0) );
	oldMode = dc_plot.SetBkMode( TRANSPARENT );

	for( i=0; i<= y_divider; i++ )
	{
		// draw the tick for y-axis
		dc_plot.MoveTo( plotRect.left -12, plotRect.bottom -5 - (i*y_intv) );
		dc_plot.LineTo( plotRect.left -3, plotRect.bottom -5 - (i*y_intv) );

		tick_str.Format( _T("%.1f"), ( ((max_range-min_range)/y_divider) * i)+min_range );

		// calculate the rectangle for text
		dc_plot.DrawText(  tick_str, &tmp_rect, DT_CALCRECT|DT_SINGLELINE );
		tick_rect.right = plotRect.left -14;
		tick_rect.left = tick_rect.right - tmp_rect.Width();
		tick_rect.top = plotRect.bottom -5 - (i*y_intv) - tmp_rect.Height()/2;
		tick_rect.bottom = tick_rect.top + tmp_rect.Height();

		// draw the text 
		dc_plot.DrawText( tick_str, &tick_rect, DT_SINGLELINE|DT_RIGHT );

	}

	// draw the minor_tick for Y axises
	dc_plot.SelectObject(&minor_tick);
	for( i=0; i< y_divider; i++ )
	{
		dc_plot.MoveTo( plotRect.left -9, plotRect.bottom -5 - (i*y_intv) - y_intv/2 );
		dc_plot.LineTo( plotRect.left -4, plotRect.bottom -5 - (i*y_intv) - y_intv/2 );
	}


	// draw the text on X-Axis
	tick_str.Format( _T("%ld"), AI_SAMPLE_COUNT );

	// calculate the rectangle for text
	dc_plot.DrawText(  tick_str, &tmp_rect, DT_CALCRECT|DT_SINGLELINE );
	tick_rect.left = plotRect.right - tmp_rect.Width()/2;
	tick_rect.right = tick_rect.left + tmp_rect.Width();
	tick_rect.top = plotRect.bottom + 2;
	tick_rect.bottom = tick_rect.top + tmp_rect.Height();

	// draw the text 
	dc_plot.DrawText( tick_str, &tick_rect, DT_SINGLELINE|DT_RIGHT );


	dc_plot.SetTextColor( oldColor );
	dc_plot.SetBkMode( oldMode );
	dc_plot.SelectObject( oldPen );
}

void C1210dmaDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	if( m_nTimer != -1 )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;
	}

	if (m_hMem != NULL)
	{
		GlobalUnfix(m_hMem);
		GlobalUnlock(m_hMem);
		GlobalFree(m_hMem);

		m_hMem = NULL;
	}

	if( OnBrush != NULL )
		::DeleteObject( OnBrush );

	if( OffBrush != NULL )
		::DeleteObject( OffBrush );

	RedPen.DeleteObject();
	YellowPen.DeleteObject();
	BluePen.DeleteObject();
	LTGreenPen.DeleteObject();
}

void C1210dmaDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
    switch ( nSBCode ) 
	{
       case SB_LINEUP :			  
		   m_fSampleRate =  m_fSampleRate + 10000.0f; 
		   if( m_fSampleRate > 2000000.0f )
			   m_fSampleRate = 2000000.0f;

              break;
       case SB_LINEDOWN:
		   m_fSampleRate =  m_fSampleRate - 10000.0f; 
		   if( m_fSampleRate < 10000.0 )
			   m_fSampleRate = 10000.0f;
           break;
    }

	SetDlgItemInt( IDC_EDIT_SAMPLE_RATE, (UINT)(m_fSampleRate) );

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void C1210dmaDlg::OnScanChanSelchange()
{
	// TODO: Add your control notification handler code here
	int nIndex;

	nIndex = m_cbScanChans.GetCurSel();
	m_wSelectedChans = (U16)( nIndex + 1);
}

void C1210dmaDlg::OnStart()
{
	// TODO: Add your control notification handler code here
	CString strTemp;
	I16 err;
	F64 fActualRate;
	CClientDC dc_plot(this);

	// redraw the background
	dc_plot.FillSolidRect( plotRect, RGB(0,0,0) );
//    GetDlgItem( IDC_BT_START )->EnableWindow(FALSE);

	m_oldY[0] = m_oldY[1] = m_oldY[2] = m_oldY[3] = -1;
	m_oldX[0] = m_oldX[1] = m_oldX[2] = m_oldX[3] = -1;

	err = UD_AI_Channel_Config( m_hCard, UD_AI_Differential, UD_AI_Differential, UD_AI_Differential,  UD_AI_Differential );
	if (err != NoError)
	{
		strTemp.Format( TEXT("UD_AI_Channel_Config error=%d"), err);
		AfxMessageBox( strTemp );
		return;
	}

	err = UD_AI_Trigger_Config( m_hCard, UD_AI_CONVSRC_INT, UD_AI_TRGMOD_POST, UD_AI_TRGSRC_SOFT, 0, 0, 0, 0 );
	if (err != NoError)
	{
		strTemp.Format( TEXT("UD_AI_Trigger_Config error=%d"), err);
		AfxMessageBox( strTemp );
		return;
	}

	err = UD_AI_AsyncDblBufferMode(m_hCard, 0); // single-buffer mode
	if (err != NoError)
	{
		strTemp.Format( TEXT("UD_AI_AsyncDblBufferMode error=%d"), err);
		AfxMessageBox( strTemp );
		return;
	}

	for( int i=0; i<m_wSelectedChans; i++ )
	{
		m_wChan[i] = i;

		m_wGain[i] = m_wRange;
	}

	err = UD_GetActualRate( m_hCard, m_fSampleRate, &fActualRate );
	err = UD_AI_ContReadMultiChannels( m_hCard, m_wSelectedChans, m_wChan, m_wGain, (U16*)m_pAIBuf, (AI_SAMPLE_COUNT*m_wSelectedChans), (F64)m_fSampleRate, ASYNCH_OP);
	if (err != NoError)
	{
		strTemp.Format( TEXT("UD_AI_ContReadMultiChannels error=%d"), err);
		AfxMessageBox( strTemp );
		return;
	}

	m_nTimer = SetTimer( 1, 200, NULL );

}

int C1210dmaDlg::display_buffer_data(U16* pBuf)
{
	CClientDC dc_plot(this);
	int nDraw_Origin_Y; 
	int cur_channel;

	int newY = -1;
	int newX = -1;
	U32 index, dwSampleCount;
	U16 wTemp;
	I16 ai_data;
	CString strTemp;

//	nDraw_Origin_Y = ( plotRect.bottom - 5 ) - n_PlotHeight/2;
	nDraw_Origin_Y = ( plotRect.bottom - 5 );


	dwSampleCount = (AI_SAMPLE_COUNT*m_wSelectedChans);
	// redraw the background
	dc_plot.FillSolidRect( plotRect, RGB(0,0,0) );

	for( index=0; index<dwSampleCount; index++ )
	{                    
		cur_channel = index%(m_wSelectedChans);
	

		wTemp = pBuf[index];

		ai_data = (I16)(wTemp);

		newY = (int)( nDraw_Origin_Y - ( (n_PlotHeight) * ((double)(ai_data + 0x7FFF)/0xFFFF)) );	

		newX = (int)( index*n_PlotWidth/dwSampleCount + plotRect.left );
		
		switch(cur_channel) 
		{
		case 0:
			dc_plot.SelectObject(&YellowPen);
			break;
		case 1:
			dc_plot.SelectObject(&LTGreenPen);
			break;
		case 2:
			dc_plot.SelectObject(&BluePen);
			break;
		case 3:
			dc_plot.SelectObject(&RedPen);
			break;
		}

		if (  m_oldX[cur_channel] == -1 ) 
		{
			dc_plot.MoveTo( newX, newY );
		}
		else
		{
			dc_plot.MoveTo( m_oldX[cur_channel], m_oldY[cur_channel] );
			dc_plot.LineTo( newX, newY );
		}

		m_oldX[cur_channel] = newX; 
		m_oldY[cur_channel] = newY;
	}

	return 0;
}

void C1210dmaDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your control notification handler code here
	BOOLEAN bStopped;
	ULONG dwAccessCnt;
	CString strTemp;
	I16 nErr;
	
	nErr = UD_AI_AsyncCheck( m_hCard, &bStopped, &dwAccessCnt);
	if( (nErr == NoError) && (bStopped == 0x01) )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;

		nErr = UD_AI_AsyncClear( m_hCard, &dwAccessCnt);

		display_buffer_data(m_pAIBuf);
	}
	else if( (nErr == ErrorAdFifoFull) )
	{
		KillTimer( m_nTimer );
		m_nTimer = -1;

		nErr = UD_AI_AsyncClear( m_hCard, &dwAccessCnt);

		AfxMessageBox( TEXT("AI FIFO Full, the acquisition data will be interrupted") );
	}

	CDialog::OnTimer(nIDEvent);
}

void C1210dmaDlg::OnBnClickedBtStop()
{
	// TODO: Add your control notification handler code here
	ULONG dwAccessCnt;
	I16 nErr;

	nErr = UD_AI_AsyncClear( m_hCard, &dwAccessCnt);
	KillTimer( m_nTimer );
	m_nTimer = -1;

}

void C1210dmaDlg::OnComboGainSelchange()
{
	// TODO: Add your control notification handler code here
	int nIndex;

	nIndex = m_cbADCGain.GetCurSel();
	switch( nIndex )
	{
	case 0: // +/-10V 
		m_wRange = AD_B_10_V;
		max_range = 10.0;	 min_range = -10.0;
		break;
	case 1: // +/-2V
		m_wRange = AD_B_2_V;
		max_range = 2.0;	min_range = -2.0;
		break;

	}
	redraw_display_area();
}


